// Copyright (C) 2023, Jakob Wakeling
// All rights reserved.

package util

import (
	"log"
	"runtime"
)

var Debug = false

func PrintFuncError(err error) {
	pc, _, _, ok := runtime.Caller(1)
	if !ok {
		log.Println(err)
		return
	}

	fn := runtime.FuncForPC(pc)
	log.Printf("[%s] %s\n", fn.Name(), err.Error())
}

func Debugln(v ...any) {
	if Debug {
		var a = []any{"\033[34m[DEBUG]\033[0m"}
		a = append(a, v...)
		log.Println(a...)
	}
}
